# -*- coding: utf-8 -*-
# Generated by Django 1.11 on 2017-10-11 11:17
from __future__ import unicode_literals

from django.db import migrations
from django.db.migrations import RunPython


def create_builtin_templates_variables(apps, schema_editor):
    template_model = apps.get_model('sommelier_bot', 'TelegramMessageTemplate')
    variable_model = apps.get_model('sommelier_bot', 'TelegramMessageTemplateTestVariable')

    comm_event_types = [
        {
            'code': 'START',
            'variables': []
        },
        {
            'code': 'UNRECOGNIZED_USER',
            'variables': []
        },
        {
            'code': 'MESSAGE_TO_CHAT',
            'variables': [
                {
                    'code': 'created_date',
                    'description': 'дата создания'
                },
                {
                    'code': 'cta.title',
                    'description': 'заголовок вопроса'
                },
                {
                    'code': 'cta.text',
                    'description': 'текст вопроса'
                },
                {
                    'code': 'category.name',
                    'description': 'название категории'
                },
                {
                    'code': 'range.name',
                    'description': 'название ассортимента'
                },
                {
                    'code': 'product.title',
                    'description': 'название товара'
                },
                {
                    'code': 'admin_url',
                    'description': 'ссылка на заявку'
                },
            ]
        },
        {
            'code': 'MESSAGE_TO_PERSON',
            'variables': [
                {
                    'code': 'created_date',
                    'description': 'дата создания'
                },
                {
                    'code': 'cta.title',
                    'description': 'заголовок вопроса'
                },
                {
                    'code': 'cta.text',
                    'description': 'текст вопроса'
                },
                {
                    'code': 'category.name',
                    'description': 'название категории'
                },
                {
                    'code': 'range.name',
                    'description': 'название ассортимента'
                },
                {
                    'code': 'product.title',
                    'description': 'название товара'
                },
                {
                    'code': 'contacts.email',
                    'description': 'email клиента'
                },
                {
                    'code': 'contacts.name',
                    'description': 'имя клиента'
                },
                {
                    'code': 'contacts.phone_number',
                    'description': 'номер телефона клиента'
                },
                {
                    'code': 'sommelier.name',
                    'description': 'имя сомелье'
                },
                {
                    'code': 'admin_url',
                    'description': 'ссылка на заявку'
                },
            ]
        },
    ]

    for comm_event_type in comm_event_types:
        template = template_model.objects.get(code=comm_event_type['code'])
        for variable in comm_event_type['variables']:
            variable_model.objects.create(
                template=template,
                code=variable['code'],
                description=variable['description'],
            )

class Migration(migrations.Migration):

    dependencies = [
        ('sommelier_bot', '0003_telegrammessagetemplatetestvariable'),
    ]

    operations = [
        RunPython(create_builtin_templates_variables)
    ]
